Startup Funding in JavaScript

Using ApexCharts with JavaScript

This Startup Funding example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// One synthetic cohort of 220 startups, each a persistent object with a name,
// sector, funding stage and the capital it has raised. The demo shows the SAME
// objects in four layouts; with plotOptions.unit.transition:'identity' every dot
// is keyed by its company name, so a given startup keeps its colour and GLIDES
// to its new place when you switch view instead of being rebuilt. Data is
// generated deterministically (seeded), so the demo is stable across reloads.
// Company names are fictional. Shared by the vanilla-js/React/Vue builds.
function makeRng(seed) {
  var s = seed >>> 0
  return function () {
    s = (Math.imul(s, 1664525) + 1013904223) >>> 0
    return s / 4294967296
  }
}
function pick(rand, items, weights) {
  var total = 0
  for (var i = 0; i < weights.length; i++) total += weights[i]
  var r = rand() * total
  for (var k = 0; k < items.length; k++) {
    r -= weights[k]
    if (r <= 0) return items[k]
  }
  return items[items.length - 1]
}

// A pool of fictional names. Combining a base with a suffix gives enough unique
// company names for a dense cohort (base x suffix), and the name is the dot's
// identity key across every view.
var BASE = [
  'Nimbus',
  'Cobalt',
  'Lumen',
  'Pathwise',
  'Flowdesk',
  'Draftly',
  'Vault',
  'Ledgr',
  'Payline',
  'Northbank',
  'Kitepay',
  'Vitalis',
  'Pulse',
  'CareLoop',
  'Mendly',
  'Orbit',
  'Quill',
  'Sable',
  'Tandem',
  'Verve',
  'Wisp',
  'Zephyr',
  'Arbor',
  'Bloomly',
  'Cinder',
  'Dune',
  'Ember',
  'Forge',
  'Glint',
  'Harbor',
  'Iris',
  'Juno',
  'Kelp',
  'Lark',
  'Mica',
  'Nova',
  'Onyx',
  'Plume',
  'Quartz',
  'Rune',
  'Slate',
  'Talon',
  'Umbra',
  'Vesper',
  'Willow',
  'Yarn',
  'Zenith',
  'Ashen',
]
var SUFFIX = [
  '',
  ' Labs',
  ' AI',
  ' Systems',
  ' Cloud',
  ' Works',
  ' Base',
  ' Go',
]

var SECTORS = ['AI', 'SaaS', 'Fintech', 'Health', 'Commerce']
var SECTOR_COLORS = ['#2563EB', '#06B6D4', '#22C55E', '#EC4899', '#F97316']
var SECTOR_W = [13, 11, 10, 8, 7]

var STAGES = ['Seed', 'Series A', 'Series B', 'Series C+']
var STAGE_COLORS = ['#BAE6FD', '#7DD3FC', '#0EA5E9', '#0369A1']
var STAGE_W = [0.42, 0.3, 0.18, 0.1]
// funding range ($M) per stage: late-stage rounds dwarf early ones
var STAGE_FUND = {
  Seed: [1, 6],
  'Series A': [8, 28],
  'Series B': [40, 95],
  'Series C+': [150, 620],
}

var COUNT = 220
var rand = makeRng(20260724)
var STARTUPS = []
for (var i = 0; i < COUNT; i++) {
  // base x suffix keeps every generated name unique (COUNT <= BASE * SUFFIX).
  var nm =
    BASE[i % BASE.length] + SUFFIX[Math.floor(i / BASE.length) % SUFFIX.length]
  var sector = pick(rand, SECTORS, SECTOR_W)
  var stage = pick(rand, STAGES, STAGE_W)
  var f = STAGE_FUND[stage]
  STARTUPS.push({
    name: nm,
    sector: sector,
    stage: stage,
    value: Math.round(f[0] + rand() * (f[1] - f[0])),
  })
}

// Group the SAME startup objects by a field, in a fixed category order (so the
// colour arrays line up). Each datum is a startup: name = identity + tooltip,
// value = funding = bubble size.
function groupBy(field, order) {
  return order.map(function (g) {
    return {
      name: g,
      data: STARTUPS.filter(function (s) {
        return s[field] === g
      }),
    }
  })
}
var bySector = groupBy('sector', SECTORS)
var byStage = groupBy('stage', STAGES)

// Tooltip body for one hovered startup.
function startupTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div><div style="opacity:0.75">' +
    o.datum.sector +
    ' &middot; ' +
    o.datum.stage +
    '</div><div style="opacity:0.75">$' +
    o.datum.value +
    'M raised</div>'
  )
}

// Category label: name + headcount, e.g. "AI (58)".
function countLabel(name, opts) {
  return name + ' (' + opts.value + ')'
}

// Each view is the SAME 220 startups, re-grouped and re-laid-out. transition
// 'identity' keeps every company's dot across the change. Switching view is a
// plain chart.updateOptions(view.options) call driven by the buttons below.
var VIEWS = [
  {
    label: 'The market',
    caption:
      '220 startups, one dot each, packed into a single cloud and coloured by sector. The whole cohort at a glance.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          sizeByValue: { enabled: false },
          clusterLabels: { show: false },
        },
      },
    },
  },
  {
    label: 'By sector',
    caption:
      'The same dots fan out into their sectors. The clusters show which corners of the market are crowded and which are thin.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'grouped',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // curved labels ride the top of each sector cluster
          clusterLabels: { show: true, position: 'top', formatter: countLabel },
        },
      },
    },
  },
  {
    label: 'By stage',
    caption:
      'Regrouped by funding stage. Every company travels to its stage bar and the classic funnel appears: many seed, few late rounds.',
    options: {
      series: byStage,
      colors: STAGE_COLORS,
      plotOptions: {
        unit: {
          layout: 'columns',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // labels sit BELOW each stage bar
          clusterLabels: {
            show: true,
            position: 'bottom',
            formatter: countLabel,
          },
        },
      },
    },
  },
  {
    label: 'By capital',
    caption:
      "Back into one cloud, but now each dot's area is the money it raised: a handful of late-stage bubbles dwarf the crowd of small rounds.",
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          clusterLabels: { show: false },
          sizeByValue: {
            enabled: true,
            maxRadius: 4.5,
            minRadius: 1.4,
            scale: 'area',
          },
        },
      },
    },
  },
]

var options = {
  series: bySector,
  chart: {
    id: 'startupCohort',
    type: 'unit',
    height: 440,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: {
      enabled: true,
      speed: 800,
    },
    toolbar: { show: false },
  },
  colors: SECTOR_COLORS,
  legend: {
    position: 'bottom',
  },
  plotOptions: {
    unit: {
      layout: 'packed',
      transition: 'identity',
      size: 4,
      spacing: 1.15,
      sortByGroup: true,
      clusterLabels: {
        show: false,
      },
      tooltip: {
        // startupTooltip lives in the shared head script.
        formatter: startupTooltip,
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// Button-driven view switch: each view is a chart.updateOptions payload; the
// unit chart's identity transition glides every dot to its new spot. (STARTUPS,
// the palettes, bySector/byStage and VIEWS live in the shared head script.)
var buttons = document.querySelectorAll('#view-nav button')
var caption = document.getElementById('caption')

function showView(i) {
  buttons.forEach(function (b, k) {
    b.classList.toggle('active', k === i)
  })
  caption.textContent = VIEWS[i].caption
  chart.updateOptions(VIEWS[i].options)
}

buttons.forEach(function (btn) {
  btn.addEventListener('click', function () {
    showView(parseInt(btn.getAttribute('data-view'), 10))
  })
})

// The chart mounts on view 0 (packed market) from its base options; just prime
// the caption so it is not empty on first paint.
caption.textContent = VIEWS[0].caption

Startup Funding in React

Using ApexCharts with React

This Startup Funding example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// One synthetic cohort of 220 startups, each a persistent object with a name,
// sector, funding stage and the capital it has raised. The demo shows the SAME
// objects in four layouts; with plotOptions.unit.transition:'identity' every dot
// is keyed by its company name, so a given startup keeps its colour and GLIDES
// to its new place when you switch view instead of being rebuilt. Data is
// generated deterministically (seeded), so the demo is stable across reloads.
// Company names are fictional. Shared by the vanilla-js/React/Vue builds.
function makeRng(seed) {
  var s = seed >>> 0
  return function () {
    s = (Math.imul(s, 1664525) + 1013904223) >>> 0
    return s / 4294967296
  }
}
function pick(rand, items, weights) {
  var total = 0
  for (var i = 0; i < weights.length; i++) total += weights[i]
  var r = rand() * total
  for (var k = 0; k < items.length; k++) {
    r -= weights[k]
    if (r <= 0) return items[k]
  }
  return items[items.length - 1]
}

// A pool of fictional names. Combining a base with a suffix gives enough unique
// company names for a dense cohort (base x suffix), and the name is the dot's
// identity key across every view.
var BASE = [
  'Nimbus',
  'Cobalt',
  'Lumen',
  'Pathwise',
  'Flowdesk',
  'Draftly',
  'Vault',
  'Ledgr',
  'Payline',
  'Northbank',
  'Kitepay',
  'Vitalis',
  'Pulse',
  'CareLoop',
  'Mendly',
  'Orbit',
  'Quill',
  'Sable',
  'Tandem',
  'Verve',
  'Wisp',
  'Zephyr',
  'Arbor',
  'Bloomly',
  'Cinder',
  'Dune',
  'Ember',
  'Forge',
  'Glint',
  'Harbor',
  'Iris',
  'Juno',
  'Kelp',
  'Lark',
  'Mica',
  'Nova',
  'Onyx',
  'Plume',
  'Quartz',
  'Rune',
  'Slate',
  'Talon',
  'Umbra',
  'Vesper',
  'Willow',
  'Yarn',
  'Zenith',
  'Ashen',
]
var SUFFIX = [
  '',
  ' Labs',
  ' AI',
  ' Systems',
  ' Cloud',
  ' Works',
  ' Base',
  ' Go',
]

var SECTORS = ['AI', 'SaaS', 'Fintech', 'Health', 'Commerce']
var SECTOR_COLORS = ['#2563EB', '#06B6D4', '#22C55E', '#EC4899', '#F97316']
var SECTOR_W = [13, 11, 10, 8, 7]

var STAGES = ['Seed', 'Series A', 'Series B', 'Series C+']
var STAGE_COLORS = ['#BAE6FD', '#7DD3FC', '#0EA5E9', '#0369A1']
var STAGE_W = [0.42, 0.3, 0.18, 0.1]
// funding range ($M) per stage: late-stage rounds dwarf early ones
var STAGE_FUND = {
  Seed: [1, 6],
  'Series A': [8, 28],
  'Series B': [40, 95],
  'Series C+': [150, 620],
}

var COUNT = 220
var rand = makeRng(20260724)
var STARTUPS = []
for (var i = 0; i < COUNT; i++) {
  // base x suffix keeps every generated name unique (COUNT <= BASE * SUFFIX).
  var nm =
    BASE[i % BASE.length] + SUFFIX[Math.floor(i / BASE.length) % SUFFIX.length]
  var sector = pick(rand, SECTORS, SECTOR_W)
  var stage = pick(rand, STAGES, STAGE_W)
  var f = STAGE_FUND[stage]
  STARTUPS.push({
    name: nm,
    sector: sector,
    stage: stage,
    value: Math.round(f[0] + rand() * (f[1] - f[0])),
  })
}

// Group the SAME startup objects by a field, in a fixed category order (so the
// colour arrays line up). Each datum is a startup: name = identity + tooltip,
// value = funding = bubble size.
function groupBy(field, order) {
  return order.map(function (g) {
    return {
      name: g,
      data: STARTUPS.filter(function (s) {
        return s[field] === g
      }),
    }
  })
}
var bySector = groupBy('sector', SECTORS)
var byStage = groupBy('stage', STAGES)

// Tooltip body for one hovered startup.
function startupTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div><div style="opacity:0.75">' +
    o.datum.sector +
    ' &middot; ' +
    o.datum.stage +
    '</div><div style="opacity:0.75">$' +
    o.datum.value +
    'M raised</div>'
  )
}

// Category label: name + headcount, e.g. "AI (58)".
function countLabel(name, opts) {
  return name + ' (' + opts.value + ')'
}

// Each view is the SAME 220 startups, re-grouped and re-laid-out. transition
// 'identity' keeps every company's dot across the change. Switching view is a
// plain chart.updateOptions(view.options) call driven by the buttons below.
var VIEWS = [
  {
    label: 'The market',
    caption:
      '220 startups, one dot each, packed into a single cloud and coloured by sector. The whole cohort at a glance.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          sizeByValue: { enabled: false },
          clusterLabels: { show: false },
        },
      },
    },
  },
  {
    label: 'By sector',
    caption:
      'The same dots fan out into their sectors. The clusters show which corners of the market are crowded and which are thin.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'grouped',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // curved labels ride the top of each sector cluster
          clusterLabels: { show: true, position: 'top', formatter: countLabel },
        },
      },
    },
  },
  {
    label: 'By stage',
    caption:
      'Regrouped by funding stage. Every company travels to its stage bar and the classic funnel appears: many seed, few late rounds.',
    options: {
      series: byStage,
      colors: STAGE_COLORS,
      plotOptions: {
        unit: {
          layout: 'columns',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // labels sit BELOW each stage bar
          clusterLabels: {
            show: true,
            position: 'bottom',
            formatter: countLabel,
          },
        },
      },
    },
  },
  {
    label: 'By capital',
    caption:
      "Back into one cloud, but now each dot's area is the money it raised: a handful of late-stage bubbles dwarf the crowd of small rounds.",
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          clusterLabels: { show: false },
          sizeByValue: {
            enabled: true,
            maxRadius: 4.5,
            minRadius: 1.4,
            scale: 'area',
          },
        },
      },
    },
  },
]

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: bySector,
    options: {
      chart: {
        id: 'startupCohort',
        type: 'unit',
        height: 440,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: {
          enabled: true,
          speed: 800,
        },
        toolbar: { show: false },
      },
      colors: SECTOR_COLORS,
      legend: {
        position: 'bottom',
      },
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          size: 4,
          spacing: 1.15,
          sortByGroup: true,
          clusterLabels: {
            show: false,
          },
          tooltip: {
            // startupTooltip lives in the shared head script.
            formatter: startupTooltip,
          },
        },
      },
    },
  })

  React.useEffect(() => {
    // Reach the live instance by its chart.id, then wire the buttons. (Data +
    // VIEWS live in the shared head script.) updateOptions drives the instance
    // directly, so no React state changes under it.
    let chart
    const timer = window.setInterval(() => {
      chart = ApexCharts.getChartByID('startupCohort')
      if (!chart) return
      window.clearInterval(timer)

      const buttons = document.querySelectorAll('#view-nav button')
      const caption = document.getElementById('caption')

      const showView = (i) => {
        buttons.forEach((b, k) => b.classList.toggle('active', k === i))
        caption.textContent = VIEWS[i].caption
        chart.updateOptions(VIEWS[i].options)
      }

      buttons.forEach((btn) => {
        btn.addEventListener('click', () => {
          showView(parseInt(btn.getAttribute('data-view'), 10))
        })
      })

      caption.textContent = VIEWS[0].caption
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="wrap">
        <h1>220 startups, four ways to look at them</h1>
        <p className="lead">
          One cohort of startups as a unit chart, one dot per company.
        </p>

        <div className="actions" id="view-nav">
          <button data-view="0" className="active">
            The market
          </button>
          <button data-view="1">By sector</button>
          <button data-view="2">By stage</button>
          <button data-view="3">By capital</button>
        </div>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={440}
            />
          </div>
        </div>

        <p className="caption" id="caption"></p>

        <div className="note">
          Every view carries the SAME 220 startup objects with
          <code>plotOptions.unit.transition: 'identity'</code>, which keys each
          dot by its company name: a specific startup keeps its colour and
          glides across every regroup, re-bin and resize rather than fading out
          and back in. Switching view is a plain{' '}
          <code>chart.updateOptions(view)</code> call. Cluster labels can sit
          above or below via <code>clusterLabels.position</code>: the sector
          labels curve over the top, the stage-bar labels sit below. The unit
          chart is a premium type; without a license it renders with a trial
          watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Startup Funding in Vue

Using ApexCharts with Vue

This Startup Funding example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>220 startups, four ways to look at them</h1>
      <p class="lead">
        One cohort of startups as a unit chart, one dot per company.
      </p>

      <div class="actions" id="view-nav">
        <button data-view="0" class="active">The market</button>
        <button data-view="1">By sector</button>
        <button data-view="2">By stage</button>
        <button data-view="3">By capital</button>
      </div>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="440"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <p class="caption" id="caption"></p>

      <div class="note">
        Every view carries the SAME 220 startup objects with
        <code>plotOptions.unit.transition: 'identity'</code>, which keys each
        dot by its company name: a specific startup keeps its colour and glides
        across every regroup, re-bin and resize rather than fading out and back
        in. Switching view is a plain
        <code>chart.updateOptions(view)</code> call. Cluster labels can sit
        above or below via <code>clusterLabels.position</code>: the sector
        labels curve over the top, the stage-bar labels sit below. The unit
        chart is a premium type; without a license it renders with a trial
        watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// One synthetic cohort of 220 startups, each a persistent object with a name,
// sector, funding stage and the capital it has raised. The demo shows the SAME
// objects in four layouts; with plotOptions.unit.transition:'identity' every dot
// is keyed by its company name, so a given startup keeps its colour and GLIDES
// to its new place when you switch view instead of being rebuilt. Data is
// generated deterministically (seeded), so the demo is stable across reloads.
// Company names are fictional. Shared by the vanilla-js/React/Vue builds.
function makeRng(seed) {
  var s = seed >>> 0
  return function () {
    s = (Math.imul(s, 1664525) + 1013904223) >>> 0
    return s / 4294967296
  }
}
function pick(rand, items, weights) {
  var total = 0
  for (var i = 0; i < weights.length; i++) total += weights[i]
  var r = rand() * total
  for (var k = 0; k < items.length; k++) {
    r -= weights[k]
    if (r <= 0) return items[k]
  }
  return items[items.length - 1]
}

// A pool of fictional names. Combining a base with a suffix gives enough unique
// company names for a dense cohort (base x suffix), and the name is the dot's
// identity key across every view.
var BASE = [
  'Nimbus', 'Cobalt', 'Lumen', 'Pathwise', 'Flowdesk', 'Draftly', 'Vault',
  'Ledgr', 'Payline', 'Northbank', 'Kitepay', 'Vitalis', 'Pulse', 'CareLoop',
  'Mendly', 'Orbit', 'Quill', 'Sable', 'Tandem', 'Verve', 'Wisp', 'Zephyr',
  'Arbor', 'Bloomly', 'Cinder', 'Dune', 'Ember', 'Forge', 'Glint', 'Harbor',
  'Iris', 'Juno', 'Kelp', 'Lark', 'Mica', 'Nova', 'Onyx', 'Plume', 'Quartz',
  'Rune', 'Slate', 'Talon', 'Umbra', 'Vesper', 'Willow', 'Yarn', 'Zenith',
  'Ashen',
]
var SUFFIX = ['', ' Labs', ' AI', ' Systems', ' Cloud', ' Works', ' Base', ' Go']

var SECTORS = ['AI', 'SaaS', 'Fintech', 'Health', 'Commerce']
var SECTOR_COLORS = ['#2563EB', '#06B6D4', '#22C55E', '#EC4899', '#F97316']
var SECTOR_W = [13, 11, 10, 8, 7]

var STAGES = ['Seed', 'Series A', 'Series B', 'Series C+']
var STAGE_COLORS = ['#BAE6FD', '#7DD3FC', '#0EA5E9', '#0369A1']
var STAGE_W = [0.42, 0.3, 0.18, 0.1]
// funding range ($M) per stage: late-stage rounds dwarf early ones
var STAGE_FUND = {
  Seed: [1, 6],
  'Series A': [8, 28],
  'Series B': [40, 95],
  'Series C+': [150, 620],
}

var COUNT = 220
var rand = makeRng(20260724)
var STARTUPS = []
for (var i = 0; i < COUNT; i++) {
  // base x suffix keeps every generated name unique (COUNT <= BASE * SUFFIX).
  var nm =
    BASE[i % BASE.length] +
    SUFFIX[Math.floor(i / BASE.length) % SUFFIX.length]
  var sector = pick(rand, SECTORS, SECTOR_W)
  var stage = pick(rand, STAGES, STAGE_W)
  var f = STAGE_FUND[stage]
  STARTUPS.push({
    name: nm,
    sector: sector,
    stage: stage,
    value: Math.round(f[0] + rand() * (f[1] - f[0])),
  })
}

// Group the SAME startup objects by a field, in a fixed category order (so the
// colour arrays line up). Each datum is a startup: name = identity + tooltip,
// value = funding = bubble size.
function groupBy(field, order) {
  return order.map(function (g) {
    return {
      name: g,
      data: STARTUPS.filter(function (s) {
        return s[field] === g
      }),
    }
  })
}
var bySector = groupBy('sector', SECTORS)
var byStage = groupBy('stage', STAGES)

// Tooltip body for one hovered startup.
function startupTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div><div style="opacity:0.75">' +
    o.datum.sector +
    ' &middot; ' +
    o.datum.stage +
    '</div><div style="opacity:0.75">$' +
    o.datum.value +
    'M raised</div>'
  )
}

// Category label: name + headcount, e.g. "AI (58)".
function countLabel(name, opts) {
  return name + ' (' + opts.value + ')'
}

// Each view is the SAME 220 startups, re-grouped and re-laid-out. transition
// 'identity' keeps every company's dot across the change. Switching view is a
// plain chart.updateOptions(view.options) call driven by the buttons below.
var VIEWS = [
  {
    label: 'The market',
    caption:
      '220 startups, one dot each, packed into a single cloud and coloured by sector. The whole cohort at a glance.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          sizeByValue: { enabled: false },
          clusterLabels: { show: false },
        },
      },
    },
  },
  {
    label: 'By sector',
    caption:
      'The same dots fan out into their sectors. The clusters show which corners of the market are crowded and which are thin.',
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'grouped',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // curved labels ride the top of each sector cluster
          clusterLabels: { show: true, position: 'top', formatter: countLabel },
        },
      },
    },
  },
  {
    label: 'By stage',
    caption:
      'Regrouped by funding stage. Every company travels to its stage bar and the classic funnel appears: many seed, few late rounds.',
    options: {
      series: byStage,
      colors: STAGE_COLORS,
      plotOptions: {
        unit: {
          layout: 'columns',
          transition: 'identity',
          sizeByValue: { enabled: false },
          // labels sit BELOW each stage bar
          clusterLabels: { show: true, position: 'bottom', formatter: countLabel },
        },
      },
    },
  },
  {
    label: 'By capital',
    caption:
      "Back into one cloud, but now each dot's area is the money it raised: a handful of late-stage bubbles dwarf the crowd of small rounds.",
    options: {
      series: bySector,
      colors: SECTOR_COLORS,
      plotOptions: {
        unit: {
          layout: 'packed',
          transition: 'identity',
          sortByGroup: true,
          clusterLabels: { show: false },
          sizeByValue: {
            enabled: true,
            maxRadius: 4.5,
            minRadius: 1.4,
            scale: 'area',
          },
        },
      },
    },
  },
]

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: bySector,
chartOptions: {
chart: {
  id: 'startupCohort',
  type: 'unit',
  height: 440,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: {
    enabled: true,
    speed: 800,
  },
  toolbar: { show: false },
},
colors: SECTOR_COLORS,
legend: {
  position: 'bottom',
},
plotOptions: {
  unit: {
    layout: 'packed',
    transition: 'identity',
    size: 4,
    spacing: 1.15,
    sortByGroup: true,
    clusterLabels: {
      show: false,
    },
    tooltip: {
      // startupTooltip lives in the shared head script.
      formatter: startupTooltip,
    },
  },
},
},
startupTimer: null,
}
},
mounted: function () {
  // Reach the live instance by its chart.id, then wire the buttons. (Data +
  // VIEWS live in the shared head script.) updateOptions drives the instance
  // directly, so no reactive data changes under it.
  var me = this
  me.startupTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('startupCohort')
    if (!chart) return
    window.clearInterval(me.startupTimer)

    var buttons = document.querySelectorAll('#view-nav button')
    var caption = document.getElementById('caption')

    function showView(i) {
      buttons.forEach(function (b, k) {
        b.classList.toggle('active', k === i)
      })
      caption.textContent = VIEWS[i].caption
      chart.updateOptions(VIEWS[i].options)
    }

    buttons.forEach(function (btn) {
      btn.addEventListener('click', function () {
        showView(parseInt(btn.getAttribute('data-view'), 10))
      })
    })

    caption.textContent = VIEWS[0].caption
  }, 50)
},
beforeDestroy: function () {
  window.clearInterval(this.startupTimer)
},,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 760px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.actions {
  margin: 20px auto 10px;
  display: flex;
  flex-wrap: wrap;
  gap: 8px;
  justify-content: center;
}
.actions button {
  color: #fff;
  background: #6b7280;
  border: none;
  padding: 8px 16px;
  font-weight: 600;
  font-size: 13px;
  border-radius: 6px;
  cursor: pointer;
}
.actions button.active {
  background: #0ea5e9;
}
.caption {
  text-align: center;
  color: #5b6b78;
  font-size: 13px;
  line-height: 1.6;
  max-width: 540px;
  margin: 0 auto;
  min-height: 34px;
}
.note {
  background: #f3f0ff;
  border-left: 3px solid #0ea5e9;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #e9e3ff;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Startup Funding in Angular

Using ApexCharts with Angular

This Startup Funding example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private makeRng = (seed: any): any => {
          var s = seed >>> 0
          return function () {
            s = (Math.imul(s, 1664525) + 1013904223) >>> 0
            return s / 4294967296
          }
        };

  private pick = (rand: any, items: any, weights: any): any => {
          var total = 0
          for (var i = 0; i < weights.length; i++) total += weights[i]
          var r = rand() * total
          for (var k = 0; k < items.length; k++) {
            r -= weights[k]
            if (r <= 0) return items[k]
          }
          return items[items.length - 1]
        };

  private BASE: any = [
          'Nimbus',
          'Cobalt',
          'Lumen',
          'Pathwise',
          'Flowdesk',
          'Draftly',
          'Vault',
          'Ledgr',
          'Payline',
          'Northbank',
          'Kitepay',
          'Vitalis',
          'Pulse',
          'CareLoop',
          'Mendly',
          'Orbit',
          'Quill',
          'Sable',
          'Tandem',
          'Verve',
          'Wisp',
          'Zephyr',
          'Arbor',
          'Bloomly',
          'Cinder',
          'Dune',
          'Ember',
          'Forge',
          'Glint',
          'Harbor',
          'Iris',
          'Juno',
          'Kelp',
          'Lark',
          'Mica',
          'Nova',
          'Onyx',
          'Plume',
          'Quartz',
          'Rune',
          'Slate',
          'Talon',
          'Umbra',
          'Vesper',
          'Willow',
          'Yarn',
          'Zenith',
          'Ashen',
        ];

  private SUFFIX: any = [
          '',
          ' Labs',
          ' AI',
          ' Systems',
          ' Cloud',
          ' Works',
          ' Base',
          ' Go',
        ];

  private SECTORS: any = ['AI', 'SaaS', 'Fintech', 'Health', 'Commerce'];

  private SECTOR_COLORS: any = ['#2563EB', '#06B6D4', '#22C55E', '#EC4899', '#F97316'];

  private SECTOR_W: any = [13, 11, 10, 8, 7];

  private STAGES: any = ['Seed', 'Series A', 'Series B', 'Series C+'];

  private STAGE_COLORS: any = ['#BAE6FD', '#7DD3FC', '#0EA5E9', '#0369A1'];

  private STAGE_W: any = [0.42, 0.3, 0.18, 0.1];

  private STAGE_FUND: any = {
          Seed: [1, 6],
          'Series A': [8, 28],
          'Series B': [40, 95],
          'Series C+': [150, 620],
        };

  private COUNT: any = 220;

  private rand: any = this.makeRng(20260724);

  private STARTUPS: any = [];

  private groupBy = (field: any, order: any): any => {
          return order.map(function (g) {
            return {
              name: g,
              data: this.STARTUPS.filter(function (s) {
                return s[field] === g
              }),
            }
          })
        };

  private bySector: any = this.groupBy('sector', this.SECTORS);

  private byStage: any = this.groupBy('stage', this.STAGES);

  private startupTooltip = (o: any): any => {
          if (!o.datum) return o.seriesName
          return (
            '<div style="font-weight:700">' +
            o.datum.name +
            '</div><div style="opacity:0.75">' +
            o.datum.sector +
            ' &middot; ' +
            o.datum.stage +
            '</div><div style="opacity:0.75">$' +
            o.datum.value +
            'M raised</div>'
          )
        };

  private countLabel = (name: any, opts: any): any => {
          return name + ' (' + opts.value + ')'
        };

  private VIEWS: any = [
          {
            label: 'The market',
            caption:
              '220 startups, one dot each, packed into a single cloud and coloured by sector. The whole cohort at a glance.',
            this.chartOptions: {
              series: this.bySector,
              colors: this.SECTOR_COLORS,
              plotOptions: {
                unit: {
                  layout: 'packed',
                  transition: 'identity',
                  sortByGroup: true,
                  sizeByValue: { enabled: false },
                  clusterLabels: { show: false },
                },
              },
            },
          },
          {
            label: 'By sector',
            caption:
              'The same dots fan out into their sectors. The clusters show which corners of the market are crowded and which are thin.',
            this.chartOptions: {
              series: this.bySector,
              colors: this.SECTOR_COLORS,
              plotOptions: {
                unit: {
                  layout: 'grouped',
                  transition: 'identity',
                  sizeByValue: { enabled: false },
                  // curved labels ride the top of each sector cluster
                  clusterLabels: { show: true, position: 'top', formatter: this.countLabel },
                },
              },
            },
          },
          {
            label: 'By stage',
            caption:
              'Regrouped by funding stage. Every company travels to its stage bar and the classic funnel appears: many seed, few late rounds.',
            this.chartOptions: {
              series: this.byStage,
              colors: this.STAGE_COLORS,
              plotOptions: {
                unit: {
                  layout: 'columns',
                  transition: 'identity',
                  sizeByValue: { enabled: false },
                  // labels sit BELOW each stage bar
                  clusterLabels: {
                    show: true,
                    position: 'bottom',
                    formatter: this.countLabel,
                  },
                },
              },
            },
          },
          {
            label: 'By capital',
            caption:
              "Back into one cloud, but now each dot's area is the money it raised: a handful of late-stage bubbles dwarf the crowd of small rounds.",
            this.chartOptions: {
              series: this.bySector,
              colors: this.SECTOR_COLORS,
              plotOptions: {
                unit: {
                  layout: 'packed',
                  transition: 'identity',
                  sortByGroup: true,
                  clusterLabels: { show: false },
                  sizeByValue: {
                    enabled: true,
                    maxRadius: 4.5,
                    minRadius: 1.4,
                    scale: 'area',
                  },
                },
              },
            },
          },
        ];

  private buttons: any = document.querySelectorAll('#view-nav button');

  private caption: any = document.getElementById('caption');

  private showView = (i: any): any => {
          this.buttons.forEach(function (b, k) {
            b.classList.toggle('active', k === i)
          })
          this.caption.textContent = this.VIEWS[i].caption
          this.chart.updateOptions(this.VIEWS[i].this.chartOptions)
        };

  public chartOptions: Partial<ChartOptions> = {
          series: this.bySector,
          chart: {
            id: 'startupCohort',
            type: 'unit',
            height: 440,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: {
              enabled: true,
              speed: 800,
            },
            toolbar: { show: false },
          },
          colors: this.SECTOR_COLORS,
          legend: {
            position: 'bottom',
          },
          plotOptions: {
            unit: {
              layout: 'packed',
              transition: 'identity',
              size: 4,
              spacing: 1.15,
              sortByGroup: true,
              clusterLabels: {
                show: false,
              },
              tooltip: {
                // startupTooltip lives in the shared head script.
                formatter: this.startupTooltip,
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    for (var i = 0; i < this.COUNT; i++) {
            // base x suffix keeps every generated name unique (COUNT <= BASE * SUFFIX).
            var nm =
              this.BASE[i % this.BASE.length] + this.SUFFIX[Math.floor(i / this.BASE.length) % this.SUFFIX.length]
            var sector = this.pick(this.rand, this.SECTORS, this.SECTOR_W)
            var stage = this.pick(this.rand, this.STAGES, this.STAGE_W)
            var f = this.STAGE_FUND[stage]
            this.STARTUPS.push({
              name: nm,
              sector: sector,
              stage: stage,
              value: Math.round(f[0] + this.rand() * (f[1] - f[0])),
            })
          }

    function showView(i) {
            this.buttons.forEach(function (b, k) {
              b.classList.toggle('active', k === i)
            })
            this.caption.textContent = this.VIEWS[i].caption
            this.chart.updateOptions(this.VIEWS[i].this.chartOptions)
          }
    this.buttons.forEach(function (btn) {
            btn.addEventListener('click', () => {
              this.showView(parseInt(btn.getAttribute('data-view'), 10))
            })
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}